Bug 1152775 - rpm will drop support for mono dependency generators
rpm will drop support for mono dependency generators
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: Mono
Current
Other Other
: P2 - High : Normal (vote)
: ---
Assigned To: Dominique Leuenberger
E-mail List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2019-10-02 12:06 UTC by Michael Schröder
Modified: 2023-02-16 23:40 UTC (History)
2 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Schröder 2019-10-02 12:06:22 UTC
rpm upstream dropped support of language specific provides/requires generators. The idea is that they get moved to the specific language packages. This has already happened for languages like perl/python/ruby, but not for mono.

rpm currently comes with three files for mono dependency generation:

/usr/lib/rpm/fileattrs/mono.attr
/usr/lib/rpm/mono-find-provides
/usr/lib/rpm/mono-find-requires

This files need to be moved to the mono-devel packages.

Note that mono-devel already has /usr/bin/mono-find-provies and /usr/bin/mono-find-requires. They are a bit different to the ones in the rpm package, so some changes may need to be merged.

The mono.attr file currently looks like this:
%__mono_provides        %{_rpmconfigdir}/mono-find-provides %{_builddir}/%{?buildsubdir} %{buildroot} %{_libdir}
%__mono_requires        %{_rpmconfigdir}/mono-find-requires %{_builddir}/%{?buildsubdir} %{buildroot} %{_libdir}
%__mono_magic           Mono/.Net assembly

You may want to usr %{_bindir} instead if %{_rpmconfigdir} if you want to use the scripts in /usr/bin.
Comment 1 Dominique Leuenberger 2020-04-29 09:51:22 UTC
This RPM fix landed in TW on Jan 15; since then, any mono package being rebuild loses its provides/requires, making the system less and less stable (just chased ip a bunch of build failures, that boiled down to this)
Comment 2 Dominique Leuenberger 2020-04-29 12:05:33 UTC
Fix submitted to devel prj: https://build.opensuse.org/request/show/798897
Comment 3 Dominique Leuenberger 2020-05-15 11:54:36 UTC
(In reply to Dominique Leuenberger from comment #2)
> Fix submitted to devel prj: https://build.opensuse.org/request/show/798897

Forwarded to Factory; currently in Staging:O
Comment 5 Max Lin 2020-05-22 13:31:59 UTC
Dominique, I've reverted mono-core in Factory because the solution isn't complete, mono specific requires indeed presented, however the mono specific provides doesn't, this results requires cannot fulfilled, eg.

on tasque package, mono(Gtk.Tasque) = 1.0.7447.20471 was listed on requires, but tasque package hasn't provides mono(Gtk.Tasque) = 1.0.7447.20471

this also affect rebuildpacs that it keeps trigger rebuild smuxi, tasque, etc., that is the  another reason I need to revert this change.
Comment 6 OBSbugzilla Bot 2020-05-27 05:20:06 UTC
This is an autogenerated message for OBS integration:
This bug (1152775) was mentioned in
https://build.opensuse.org/request/show/809123 Factory / mono-core
Comment 8 OBSbugzilla Bot 2020-05-27 10:10:06 UTC
This is an autogenerated message for OBS integration:
This bug (1152775) was mentioned in
https://build.opensuse.org/request/show/809279 Factory / mono-core
Comment 10 OBSbugzilla Bot 2020-05-28 07:40:06 UTC
This is an autogenerated message for OBS integration:
This bug (1152775) was mentioned in
https://build.opensuse.org/request/show/809780 Factory / mono-core
Comment 11 Dominique Leuenberger 2020-06-03 14:24:14 UTC
(In reply to OBSbugzilla Bot from comment #10)
> This is an autogenerated message for OBS integration:
> This bug (1152775) was mentioned in
> https://build.opensuse.org/request/show/809780 Factory / mono-core

=>? FIXED